/********************************************************************
 *	ȈՃj^
 ********************************************************************
 */
#include <string.h>
#include "usb/typedefs.h"
#include "usb/usb.h"
#include "io_cfg.h"
#include "monit.h"
#include "hidcmd.h"
#include "picwrt.h"
#include "timer2.h"

/********************************************************************
 *	XCb`
 ********************************************************************
 */
/********************************************************************
 *	`
 ********************************************************************
 */
#if defined(__18F14K50)
#define	SOFTWARE_SPI_MODE	1
#define	DEVID	DEV_ID_PIC18F14K	//0x14
#else
#define	SOFTWARE_SPI_MODE	1		//18F4550SPIMf[^.
#define	DEVID	DEV_ID_PIC			//0x25
#endif

#define	VER_H	1
#define	VER_L	1

extern void user_cmd(int arg);

/********************************************************************
 *	f[^
 ********************************************************************
 */
#pragma udata access accessram


//	AVRݗpReNXg.
uchar near page_mode;
uchar near page_addr;
uchar near page_addr_h;

//	f[^胂[h̐ݒ.
uchar near  poll_mode;	// 00=ݒ  0xa0=AiOTv  0xc0=fW^Tv
						// 0xc9=runR}h^[~l[g      
uchar near *poll_addr;	//

//	R}h̕ԐMKvȂ1Zbg.
uchar near ToPcRdy;

#pragma udata SomeSectionName1
Packet PacketFromPC;			//̓pPbg 64byte

#pragma udata SomeSectionName2
Packet PacketToPC;				//o̓pPbg 64byte


#define	Cmd0	PacketFromPC.cmd
#define	Data0	PacketFromPC.data[0]
#define	Mask1	PacketFromPC.data[1]

		uchar	puts_mode;

extern	uchar 	puts_buf[];
extern	uchar 	puts_ptr;

/********************************************************************
 *	ISPW[ CN[h.
 ********************************************************************
 */
#pragma code

#if	SOFTWARE_SPI_MODE
#include "usi_pic18s.h"
#else
#include "usi_pic18.h"
#endif


static void isp_command(uchar *data) {
	uchar i;
	for (i=0;i<4;i++) {
		PacketToPC.raw[i]=usi_trans(data[i]);
	}
}

/********************************************************************
 *	.
 ********************************************************************
 */
void UserInit(void)
{
    mInitAllLEDs();
	timer2_interval(5);	// '-d5'
	poll_mode = 0;
	poll_addr = 0;
	puts_ptr = 0;
	ToPcRdy = 0;
}


/********************************************************************
 *	ڑeXg̕ԓ
 ********************************************************************
 */
void cmd_echo(void)
{
	PacketToPC.raw[1]=DEVID;				// PIC25/14K
	PacketToPC.raw[2]=VER_L;				// version.L
	PacketToPC.raw[3]=VER_H;				// version.H
	PacketToPC.raw[4]=PacketFromPC.raw[1];	// ECHOBACK
	ToPcRdy = 1;
}

/********************************************************************
 *	[ǂݏo
 ********************************************************************
 */
void cmd_peek(void)
{
	uchar i,size,area;
	uchar *p;

 	size = PacketFromPC.size;
	area = size & 0xc0;
	size = size & 0x3f;
 	p = (uchar*)PacketFromPC.adrs;

	if(area) {
//		PacketFromPC.data[0]=0;	// TBLPTRU[NA.
		TBLPTR = (unsigned short long)PacketFromPC.adrs;
		
		for(i=0;i<size;i++) {
				_asm
				tblrdpostinc
				_endasm
			PacketToPC.raw[i]=TABLAT;
		}
	}else{
		for(i=0;i<size;i++) {
			PacketToPC.raw[i]=*p++;
		}
	}
	ToPcRdy = 1;
}
/********************************************************************
 *	[
 ********************************************************************
 */
void cmd_poke(void)
{
	uchar size,area;
	uchar *p;
 	area = PacketFromPC.size;
 	p = (uchar*)PacketFromPC.adrs;

	if( Mask1 ) {	//}XN.
		*p = (*p & Mask1) | Data0;
	}else{			//ʏ폑.
		*p = Data0;
	}
}

/********************************************************************
 *	Ԓnw̎s
 ********************************************************************
 */
void cmd_exec(void)
{
	PCLATU=0;
	PCLATH=PacketFromPC.raw[3];	// adrs_h
#if	0
	PCL   =PacketFromPC.raw[2];	// adrs_l
#else
	{
		uchar adrs_l=PacketFromPC.raw[2];
		_asm
		movf	adrs_l,1,1
		movwf	PCL,0
		_endasm
	}
#endif
}


/********************************************************************
 *	puts zXgɕԑ.
 ********************************************************************
 */
void cmd_get_string(void)
{
	PacketToPC.raw[0] =  puts_mode;	//'p';		/* R}hsHOSTɒm点. */
	PacketToPC.raw[1] =  puts_ptr;	// .
	memcpy( (void*)&PacketToPC.raw[2] , (void*)puts_buf , puts_ptr & 0x3f);	//.
	puts_ptr = 0;
	ToPcRdy = 1;
}
/********************************************************************
 *	[U[`֐̎s.
 ********************************************************************
 */
void cmd_user_cmd(void)
{
	puts_ptr = 0;
	puts_mode = 'p';
	user_cmd(PacketFromPC.adrs);
	puts_mode = 'q';
}


/********************************************************************
 *	f[^̘AMs.
 ********************************************************************
 */
void make_report(void)
{
	PacketToPC.raw[0] =  0xaa;		/* R}hsHOSTɒm点. */
	PacketToPC.raw[1] =  poll_mode;
	PacketToPC.raw[2] = *poll_addr;
	ToPcRdy = 1;
}
/********************************************************************
 *	f[^胂[h̐ݒ
 ********************************************************************
 */
void cmd_set_mode(void)
{
	poll_mode = PacketFromPC.size;
	poll_addr = (uchar near *) PacketFromPC.adrs;
	make_report();
}

/********************************************************************
 *	AVRC^[̐ݒ
 ********************************************************************
 */
void cmd_set_status(void)
{
/* ISPp̃sHi-Z */
/* ISPڍs̎菇At@[Ŏ */
	if(PacketFromPC.raw[2] & 0x10) {// RST̏ꍇ
		ispDisconnect();
	}else{
		if(PacketFromPC.raw[2] & 0x80) {// RSTԂSCK H SCKpXv
			ispSckPulse();
		} else {
			ispConnect();
		}
	}
	PacketToPC.raw[0] = 0xaa;	/* R}hsHOSTɒm点. */
	ToPcRdy = 1;
}
/********************************************************************
 *	PORTւ̏o͐
 ********************************************************************
 */
void cmd_tx(void)
{
	isp_command( &PacketFromPC.raw[1]);
	ToPcRdy = Cmd0 & 1;	// LSBOnȂԓKv.
}
/********************************************************************
 *	y[WAhX̐ݒ.
 ********************************************************************
 */
void cmd_set_page(void)
{
	page_mode = PacketFromPC.raw[1];
	page_addr = PacketFromPC.raw[2];
	page_addr_h = PacketFromPC.raw[3];
}
/********************************************************************
 *	ISP݃NbN̐ݒ.
 ********************************************************************
 */
void cmd_set_delay(void)
{
	usi_set_delay(PacketFromPC.raw[1]);	// '-dN'
}

/********************************************************************
 *	AVR(Fusion)R}h̎s
 ********************************************************************
 *	Cmd0 : 0x20`0x27
 */
void cmd_page_tx(void)
{
	uchar i;
	//
	//	page_writeJnpage_addrdata[1]ŏ.
	//
	if( Cmd0 & (HIDASP_PAGE_TX_START & MODE_MASK)) {
		page_mode = 0x40;
		page_addr = 0;
		page_addr_h = 0;
	}
	//
	//	page_write (܂page_read) ̎s.
	//
	for(i=0;i<PacketFromPC.size;i++) {
		usi_trans(page_mode);
		usi_trans(page_addr_h);
		usi_trans(page_addr);
		PacketToPC.raw[i]=usi_trans(PacketFromPC.raw[i+2]);

		if (page_mode & 0x88) { // EEPROM or FlashH
			page_addr++;
			if(page_addr==0) {page_addr_h++;}
			page_mode&=~0x08;
		} else {
			page_mode|=0x08;
		}
	}
	//
	//	isp_command(Flash)̎s.
	//
	if( Cmd0 & (HIDASP_PAGE_TX_FLUSH & MODE_MASK)) {
		isp_command( &PacketFromPC.raw[PacketFromPC.size+2]);
	}
	ToPcRdy = Cmd0 & 1;	// LSBOnȂԓKv.
}

/********************************************************************
 *	AVRC^[nR}hMƎs.
 ********************************************************************
 *	Cmd0 : 0x20`0x2F
 */
void cmd_avrspx(void)
{
	if(Cmd0 < (HIDASP_CMD_TX) ) 	{cmd_page_tx();}	// 0x20`0x27

	// 0x28`0x2F
	else if(Cmd0==HIDASP_SET_STATUS){cmd_set_status();}
	else if(Cmd0==HIDASP_SET_PAGE) 	{cmd_set_page();}
	else if(Cmd0==HIDASP_CMD_TX) 	{cmd_tx();}
	else if(Cmd0==HIDASP_CMD_TX_1) 	{cmd_tx();}
	else if(Cmd0==HIDASP_SET_DELAY) {cmd_set_delay();}
}


/********************************************************************
 *	j^R}hMƎs.
 ********************************************************************
 */
void ProcessIO(void)
{
	// ԓpPbgł邱ƁAA
	// Ώۂ̎Mf[^.
	if((ToPcRdy == 0) && (!mHIDRxIsBusy())) {

		//Mf[^΁AMf[^󂯎.
		HIDRxReport((char *)&PacketFromPC, 64);
		PacketToPC.raw[0]=Cmd0;		// CMD ECHOBACK

		//R}hɑΉ鏈Ăяo.
		if(Cmd0 >= HIDASP_PAGE_TX)  {cmd_avrspx();}	// AVRC^[R}h.
		else if(Cmd0 >= PICSPX_SETADRS24){cmd_picspx();}	// PICC^[R}h.
		else if(Cmd0==HIDASP_PEEK) 	{cmd_peek();}	// [ǂݏo.
		else if(Cmd0==HIDASP_POKE) 	{cmd_poke();}	// [.
		else if(Cmd0==HIDASP_JMP) 	{cmd_exec();}	// s.
		else if(Cmd0==HIDASP_SET_MODE)  {cmd_set_mode();}
		else if(Cmd0==HIDASP_GET_STRING){cmd_get_string();}
		else if(Cmd0==HIDASP_USER_CMD)  {cmd_user_cmd();}
		else if(Cmd0==HIDASP_TEST) 	{cmd_echo();}	// ڑeXg.
	}

	// KvȂAԓpPbgC^vg](EP1)ŃzXgPCɕԋp.
	if( ToPcRdy ) {
		if(!mHIDTxIsBusy()) {
			HIDTxReport((char *)&PacketToPC, 64);
			ToPcRdy = 0;

			if(poll_mode!=0) {
				if(mHIDRxIsBusy()) {	//R}hȂ著葱.
					make_report();
				}
			}
		}
	}
}
/********************************************************************
 *	
 ********************************************************************
 */
